package com.maintain.business.service;

import cn.hutool.core.lang.tree.Tree;
import com.maintain.business.domain.ErpMaterialType;
import com.maintain.business.domain.vo.ErpMaterialTypeVo;
import com.maintain.business.domain.bo.ErpMaterialTypeBo;
import com.maintain.common.core.page.TableDataInfo;
import com.maintain.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 物资分类Service接口
 *
 * @author liushuai
 * @date 2025-04-03
 */
public interface IErpMaterialTypeService {

    /**
     * 查询物资分类
     */
    ErpMaterialTypeVo queryById(Long typeId);

    /**
     * 查询物资分类列表
     */
    TableDataInfo<ErpMaterialTypeVo> queryPageList(ErpMaterialTypeBo bo, PageQuery pageQuery);

    /**
     * 查询物资分类树
     */
    List<Tree<Long>> queryTreeList(ErpMaterialTypeBo bo);

    /**
     * 查询物资分类列表
     */
    List<ErpMaterialTypeVo> queryList(ErpMaterialTypeBo bo);

    /**
     * 新增物资分类
     */
    Boolean insertByBo(ErpMaterialTypeBo bo);

    /**
     * 修改物资分类
     */
    Boolean updateByBo(ErpMaterialTypeBo bo);

    /**
     * 校验并批量删除物资分类信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
